Name:           earcut-hpp
Summary:        Fast, header-only polygon triangulation 
Version:        2.2.4
Release:    1%{?dist}

License:        ISC
URL:            https://github.com/mapbox/earcut.hpp

Source0:         %{url}/archive/v%{version}/earcut.hpp-%{version}.tar.gz

BuildRequires:  gcc-c++
BuildRequires:  cmake
BuildRequires:  ninja-build

BuildRequires:  pkgconfig(opengl)


%global debug_package %{nil}

%global common_description %{expand:
A C++ port of earcut.js, a fast, header-only polygon triangulation library.

The library implements a modified ear slicing algorithm, optimized by z-order
curve hashing and extended to handle holes, twisted polygons, degeneracies and
self-intersections in a way that doesn’t guarantee correctness of
triangulation, but attempts to always produce acceptable results for practical
data like geographical shapes.

It’s based on ideas from FIST: Fast Industrial-Strength Triangulation of
Polygons by Martin Held and Triangulation by Ear Clipping by David Eberly.}

%description %{common_description}


%package devel
Summary:        %{summary}

BuildArch:      noarch

Provides:       %{name}-static = %{version}-%{release}

%description devel %{common_description}


%prep
%autosetup -n earcut.hpp-%{version} -p1
sed -r -i 's/(setprecision\()6(\))/\116\2/' test/test.cpp


%build
export CXXFLAGS="${CXXFLAGS-} -ffp-contract=off"

%cmake \
    -DEARCUT_BUILD_TESTS:BOOL=ON \
    -DEARCUT_BUILD_BENCH:BOOL=OFF \
    -DEARCUT_BUILD_VIZ:BOOL=OFF \
    -DEARCUT_WARNING_IS_ERROR:BOOL=OFF \
    -GNinja
%cmake_build


%install
install -D -t '%{buildroot}%{_includedir}/mapbox' -p -m 0644 \
    'include/mapbox/earcut.hpp'


%check
%{_vpath_builddir}/tests


%files devel
%license LICENSE
%doc CHANGELOG.md
%doc README.md

%dir %{_includedir}/mapbox

%{_includedir}/mapbox/earcut.hpp


%changelog
* Fri Apr 12 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.2.4-1
- initial build
